#
# IRevisionManagerZMI
#
# Copyright (c) 2001-2003 by Philipp "philiKON" von Weitershausen
#
# This software is distributed under the terms of the Mozilla Public License
# (MPL)
#

"""
$Id: IRevisionManagerZMI.py,v 1.3 2003/01/27 15:34:37 philipp Exp $
"""

from Interface import Interface, Attribute

class IRevisionManagerZMI(Interface):
    """
    ZMI interface for RevisionManager
    """
    
    rm_importForm = Attribute("""
        Import form. Show objects that can be imported.
        """)
        
    def rm_import(vendor_tag, release_tag, log_message, paths=[], REQUEST=None):
        """
        Import files specified in the 'paths' sequence.
        """

    rm_mapFSObjectsForm = Attribute("""
        Mapping file system files to objects form. Show a list of appropriate files.
        """)

    def rm_mapFSObjects(items=[], REQUEST=None):
        """
        Map file system files to objects. Parameter 'items' is a sequence of dictionaries.
        """

    rm_configForm = Attribute("""
        Configuration form.
        """)
        
    def rm_config(REQUEST):
        """
        Save configuration settings.
        """

    rm_addRemoveForm = Attribute("""
        Object add/remove form.
        """)

    def rm_addObjects(new_paths=[], REQUEST=None):
        """
        Add objects to the repository.
        """

    def rm_removeObjects(paths=[], REQUEST=None):
        """
        remove objects from RevisionManager's list and delete their
        equivalents in the CVS repository.
        """

    rm_commitForm = Attribute("""
        Commit form.
        """)
        
    def rm_commit(paths=[], log_message="commit", REQUEST=None):
        """
        Commit changes.
        """

    rm_statusForm = Attribute("""
        Status form. Show objects' status.
        """)

    rm_updateForm = Attribute("""
        Update form. Display update output.
        """)

    def rm_setTag(tag, paths=[], REQUEST=None):
        """
        Set tag on files specified in 'paths'.
        """

    def rm_setRevision(setrevision, paths=[], REQUEST=None):
        """
        Set a file's revision to 'setrevision'.
        """

    rm_detailsForm = Attribute("""
        Details form. Show detailled status information about objects.
        """)

    def rm_revertRevision(path, revision, REQUEST=None):
        """
        Overwrite an object's data with its data from an older revision
        """

    rm_logForm = Attribute("""
        log form. Show an object's history log.
        """)

    rm_diffForm = Attribute("""
        Diff form. Show the diff of an object's two revisions.
        """)
