
"""
$Id: testShellCmdProc.py,v 1.3 2003/02/08 14:50:14 philipp Exp $
"""

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.RevisionManager.ShellCommandProcessor import ShellCommandProcessor
from Products.RevisionManager.IShellCommandProcessor import IShellCommandProcessor

ZopeTestCase.installProduct('RevisionManager')

stubstring = "aGl678rjtl3jASGjsljfjh357lerg"

class ShellCmdProcTest(ZopeTestCase.ZopeTestCase):
    """
    Test ShellCommandProcessor
    Will only work on UNIX-like operating systems
    """

    def test_verify_interface(self):
        """Verify interface implementation"""
        from Interface.Verify import verifyClass
        self.failUnless(verifyClass(IShellCommandProcessor, ShellCommandProcessor))

    def test_stdout(self):
        """Test stdout output"""
        shellproc = ShellCommandProcessor()
        values = shellproc.processStreams('echo -n "%s"' % stubstring)
        self.assertEqual(values[0], 0)
        self.assertEqual(values[1], stubstring)
        self.assertEqual(values[2], "")
    
    def test_stderr(self):
        """Test stderr output"""
        shellproc = ShellCommandProcessor()
        values = shellproc.processStreams('echo -n "%s" > /dev/stderr' % stubstring)
        self.assertEqual(values[0], 0)
        self.assertEqual(values[1], "")
        self.assertEqual(values[2], stubstring)

    def test_pipe(self):
        """Test pipe input"""
        shellproc = ShellCommandProcessor()
        values = shellproc.processStreams("cat", stubstring)
        self.assertEqual(values[0], 0)
        self.assertEqual(values[1], stubstring)
        self.assertEqual(values[2], "")
        
    def test_falseReturnCode(self):
        """Test false return code"""
        shellproc = ShellCommandProcessor()
        values = shellproc.processStreams("/bin/false")
        self.failUnless(values[0]!=0)
        
    def test_trueReturnCode(self):
        """Test true return code"""
        shellproc = ShellCommandProcessor()
        values = shellproc.processStreams("/bin/true")
        self.assertEqual(values[0], 0)

if __name__ == '__main__':
    framework(descriptions=1, verbosity=2)
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(ShellCmdProcTest))
        return suite
